// This file is autogenerated, do not manually edit.

use crate::zbus::proxy;

/// Proxy object for `org.freedesktop.login1.Manager`.
#[proxy(
    interface = "org.freedesktop.login1.Manager",
    gen_blocking = false,
    default_service = "org.freedesktop.login1",
    default_path = "/org/freedesktop/login1"
)]
trait Manager {
    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#GetSession()) Call interface method `GetSession`.
    #[zbus(name = "GetSession")]
    fn get_session(
        &self,
        session_id: String,
    ) -> crate::zbus::Result<crate::zvariant::OwnedObjectPath>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#GetSessionByPID()) Call interface method `GetSessionByPID`.
    #[zbus(name = "GetSessionByPID")]
    fn get_session_by_pid(&self, pid: u32)
        -> crate::zbus::Result<crate::zvariant::OwnedObjectPath>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#GetUser()) Call interface method `GetUser`.
    #[zbus(name = "GetUser")]
    fn get_user(&self, uid: u32) -> crate::zbus::Result<crate::zvariant::OwnedObjectPath>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#GetUserByPID()) Call interface method `GetUserByPID`.
    #[zbus(name = "GetUserByPID")]
    fn get_user_by_pid(&self, pid: u32) -> crate::zbus::Result<crate::zvariant::OwnedObjectPath>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#GetSeat()) Call interface method `GetSeat`.
    #[zbus(name = "GetSeat")]
    fn get_seat(&self, seat_id: String) -> crate::zbus::Result<crate::zvariant::OwnedObjectPath>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#ListSessions()) Call interface method `ListSessions`.
    #[zbus(name = "ListSessions")]
    fn list_sessions(
        &self,
    ) -> crate::zbus::Result<
        Vec<(
            String,
            u32,
            String,
            String,
            crate::zvariant::OwnedObjectPath,
        )>,
    >;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#ListSessionsEx()) Call interface method `ListSessionsEx`.
    #[zbus(name = "ListSessionsEx")]
    fn list_sessions_ex(
        &self,
    ) -> crate::zbus::Result<
        Vec<(
            String,
            u32,
            String,
            String,
            u32,
            String,
            String,
            bool,
            u64,
            crate::zvariant::OwnedObjectPath,
        )>,
    >;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#ListUsers()) Call interface method `ListUsers`.
    #[zbus(name = "ListUsers")]
    fn list_users(
        &self,
    ) -> crate::zbus::Result<Vec<(u32, String, crate::zvariant::OwnedObjectPath)>>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#ListSeats()) Call interface method `ListSeats`.
    #[zbus(name = "ListSeats")]
    fn list_seats(&self) -> crate::zbus::Result<Vec<(String, crate::zvariant::OwnedObjectPath)>>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#ListInhibitors()) Call interface method `ListInhibitors`.
    #[zbus(name = "ListInhibitors")]
    fn list_inhibitors(
        &self,
    ) -> crate::zbus::Result<Vec<(String, String, String, String, u32, u32)>>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#CreateSession()) Call interface method `CreateSession`.
    #[zbus(name = "CreateSession")]
    fn create_session(
        &self,
        uid: u32,
        pid: u32,
        service: String,
        typelabel: String,
        class: String,
        desktop: String,
        seat_id: String,
        vtnr: u32,
        tty: String,
        display: String,
        remote: bool,
        remote_user: String,
        remote_host: String,
        properties: Vec<(String, crate::zvariant::OwnedValue)>,
    ) -> crate::zbus::Result<(
        String,
        crate::zvariant::OwnedObjectPath,
        String,
        crate::zvariant::OwnedFd,
        u32,
        String,
        u32,
        bool,
    )>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#CreateSessionWithPIDFD()) Call interface method `CreateSessionWithPIDFD`.
    #[zbus(name = "CreateSessionWithPIDFD")]
    fn create_session_with_pidfd(
        &self,
        uid: u32,
        pidfd: crate::zvariant::OwnedFd,
        service: String,
        typelabel: String,
        class: String,
        desktop: String,
        seat_id: String,
        vtnr: u32,
        tty: String,
        display: String,
        remote: bool,
        remote_user: String,
        remote_host: String,
        flags: u64,
        properties: Vec<(String, crate::zvariant::OwnedValue)>,
    ) -> crate::zbus::Result<(
        String,
        crate::zvariant::OwnedObjectPath,
        String,
        crate::zvariant::OwnedFd,
        u32,
        String,
        u32,
        bool,
    )>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#ReleaseSession()) Call interface method `ReleaseSession`.
    #[zbus(name = "ReleaseSession")]
    fn release_session(&self, session_id: String) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#ActivateSession()) Call interface method `ActivateSession`.
    #[zbus(name = "ActivateSession")]
    fn activate_session(&self, session_id: String) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#ActivateSessionOnSeat()) Call interface method `ActivateSessionOnSeat`.
    #[zbus(name = "ActivateSessionOnSeat")]
    fn activate_session_on_seat(
        &self,
        session_id: String,
        seat_id: String,
    ) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#LockSession()) Call interface method `LockSession`.
    #[zbus(name = "LockSession")]
    fn lock_session(&self, session_id: String) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#UnlockSession()) Call interface method `UnlockSession`.
    #[zbus(name = "UnlockSession")]
    fn unlock_session(&self, session_id: String) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#LockSessions()) Call interface method `LockSessions`.
    #[zbus(name = "LockSessions")]
    fn lock_sessions(&self) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#UnlockSessions()) Call interface method `UnlockSessions`.
    #[zbus(name = "UnlockSessions")]
    fn unlock_sessions(&self) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#KillSession()) Call interface method `KillSession`.
    #[zbus(name = "KillSession")]
    fn kill_session(
        &self,
        session_id: String,
        who: String,
        signal_number: i32,
    ) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#KillUser()) Call interface method `KillUser`.
    #[zbus(name = "KillUser")]
    fn kill_user(&self, uid: u32, signal_number: i32) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#TerminateSession()) Call interface method `TerminateSession`.
    #[zbus(name = "TerminateSession")]
    fn terminate_session(&self, session_id: String) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#TerminateUser()) Call interface method `TerminateUser`.
    #[zbus(name = "TerminateUser")]
    fn terminate_user(&self, uid: u32) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#TerminateSeat()) Call interface method `TerminateSeat`.
    #[zbus(name = "TerminateSeat")]
    fn terminate_seat(&self, seat_id: String) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SetUserLinger()) Call interface method `SetUserLinger`.
    #[zbus(name = "SetUserLinger")]
    fn set_user_linger(&self, uid: u32, enable: bool, interactive: bool)
        -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#AttachDevice()) Call interface method `AttachDevice`.
    #[zbus(name = "AttachDevice")]
    fn attach_device(
        &self,
        seat_id: String,
        sysfs_path: String,
        interactive: bool,
    ) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#FlushDevices()) Call interface method `FlushDevices`.
    #[zbus(name = "FlushDevices")]
    fn flush_devices(&self, interactive: bool) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#PowerOff()) Call interface method `PowerOff`.
    #[zbus(name = "PowerOff")]
    fn power_off(&self, interactive: bool) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#PowerOffWithFlags()) Call interface method `PowerOffWithFlags`.
    #[zbus(name = "PowerOffWithFlags")]
    fn power_off_with_flags(&self, flags: u64) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#Reboot()) Call interface method `Reboot`.
    #[zbus(name = "Reboot")]
    fn reboot(&self, interactive: bool) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#RebootWithFlags()) Call interface method `RebootWithFlags`.
    #[zbus(name = "RebootWithFlags")]
    fn reboot_with_flags(&self, flags: u64) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#Halt()) Call interface method `Halt`.
    #[zbus(name = "Halt")]
    fn halt(&self, interactive: bool) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#HaltWithFlags()) Call interface method `HaltWithFlags`.
    #[zbus(name = "HaltWithFlags")]
    fn halt_with_flags(&self, flags: u64) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#Suspend()) Call interface method `Suspend`.
    #[zbus(name = "Suspend")]
    fn suspend(&self, interactive: bool) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SuspendWithFlags()) Call interface method `SuspendWithFlags`.
    #[zbus(name = "SuspendWithFlags")]
    fn suspend_with_flags(&self, flags: u64) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#Hibernate()) Call interface method `Hibernate`.
    #[zbus(name = "Hibernate")]
    fn hibernate(&self, interactive: bool) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#HibernateWithFlags()) Call interface method `HibernateWithFlags`.
    #[zbus(name = "HibernateWithFlags")]
    fn hibernate_with_flags(&self, flags: u64) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#HybridSleep()) Call interface method `HybridSleep`.
    #[zbus(name = "HybridSleep")]
    fn hybrid_sleep(&self, interactive: bool) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#HybridSleepWithFlags()) Call interface method `HybridSleepWithFlags`.
    #[zbus(name = "HybridSleepWithFlags")]
    fn hybrid_sleep_with_flags(&self, flags: u64) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SuspendThenHibernate()) Call interface method `SuspendThenHibernate`.
    #[zbus(name = "SuspendThenHibernate")]
    fn suspend_then_hibernate(&self, interactive: bool) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SuspendThenHibernateWithFlags()) Call interface method `SuspendThenHibernateWithFlags`.
    #[zbus(name = "SuspendThenHibernateWithFlags")]
    fn suspend_then_hibernate_with_flags(&self, flags: u64) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#Sleep()) Call interface method `Sleep`.
    #[zbus(name = "Sleep")]
    fn sleep(&self, flags: u64) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#CanPowerOff()) Call interface method `CanPowerOff`.
    #[zbus(name = "CanPowerOff")]
    fn can_power_off(&self) -> crate::zbus::Result<String>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#CanReboot()) Call interface method `CanReboot`.
    #[zbus(name = "CanReboot")]
    fn can_reboot(&self) -> crate::zbus::Result<String>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#CanHalt()) Call interface method `CanHalt`.
    #[zbus(name = "CanHalt")]
    fn can_halt(&self) -> crate::zbus::Result<String>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#CanSuspend()) Call interface method `CanSuspend`.
    #[zbus(name = "CanSuspend")]
    fn can_suspend(&self) -> crate::zbus::Result<String>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#CanHibernate()) Call interface method `CanHibernate`.
    #[zbus(name = "CanHibernate")]
    fn can_hibernate(&self) -> crate::zbus::Result<String>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#CanHybridSleep()) Call interface method `CanHybridSleep`.
    #[zbus(name = "CanHybridSleep")]
    fn can_hybrid_sleep(&self) -> crate::zbus::Result<String>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#CanSuspendThenHibernate()) Call interface method `CanSuspendThenHibernate`.
    #[zbus(name = "CanSuspendThenHibernate")]
    fn can_suspend_then_hibernate(&self) -> crate::zbus::Result<String>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#CanSleep()) Call interface method `CanSleep`.
    #[zbus(name = "CanSleep")]
    fn can_sleep(&self) -> crate::zbus::Result<String>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#ScheduleShutdown()) Call interface method `ScheduleShutdown`.
    #[zbus(name = "ScheduleShutdown")]
    fn schedule_shutdown(&self, typelabel: String, usec: u64) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#CancelScheduledShutdown()) Call interface method `CancelScheduledShutdown`.
    #[zbus(name = "CancelScheduledShutdown")]
    fn cancel_scheduled_shutdown(&self) -> crate::zbus::Result<bool>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#Inhibit()) Call interface method `Inhibit`.
    #[zbus(name = "Inhibit")]
    fn inhibit(
        &self,
        what: String,
        who: String,
        why: String,
        mode: String,
    ) -> crate::zbus::Result<crate::zvariant::OwnedFd>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#CanRebootParameter()) Call interface method `CanRebootParameter`.
    #[zbus(name = "CanRebootParameter")]
    fn can_reboot_parameter(&self) -> crate::zbus::Result<String>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SetRebootParameter()) Call interface method `SetRebootParameter`.
    #[zbus(name = "SetRebootParameter")]
    fn set_reboot_parameter(&self, parameter: String) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#CanRebootToFirmwareSetup()) Call interface method `CanRebootToFirmwareSetup`.
    #[zbus(name = "CanRebootToFirmwareSetup")]
    fn can_reboot_to_firmware_setup(&self) -> crate::zbus::Result<String>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SetRebootToFirmwareSetup()) Call interface method `SetRebootToFirmwareSetup`.
    #[zbus(name = "SetRebootToFirmwareSetup")]
    fn set_reboot_to_firmware_setup(&self, enable: bool) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#CanRebootToBootLoaderMenu()) Call interface method `CanRebootToBootLoaderMenu`.
    #[zbus(name = "CanRebootToBootLoaderMenu")]
    fn can_reboot_to_boot_loader_menu(&self) -> crate::zbus::Result<String>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SetRebootToBootLoaderMenu()) Call interface method `SetRebootToBootLoaderMenu`.
    #[zbus(name = "SetRebootToBootLoaderMenu")]
    fn set_reboot_to_boot_loader_menu(&self, timeout: u64) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#CanRebootToBootLoaderEntry()) Call interface method `CanRebootToBootLoaderEntry`.
    #[zbus(name = "CanRebootToBootLoaderEntry")]
    fn can_reboot_to_boot_loader_entry(&self) -> crate::zbus::Result<String>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SetRebootToBootLoaderEntry()) Call interface method `SetRebootToBootLoaderEntry`.
    #[zbus(name = "SetRebootToBootLoaderEntry")]
    fn set_reboot_to_boot_loader_entry(&self, boot_loader_entry: String)
        -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SetWallMessage()) Call interface method `SetWallMessage`.
    #[zbus(name = "SetWallMessage")]
    fn set_wall_message(&self, wall_message: String, enable: bool) -> crate::zbus::Result<()>;

    /// Receive `SessionNew` signal.
    #[zbus(signal, name = "SessionNew")]
    fn session_new(
        &self,
        session_id: String,
        object_path: crate::zvariant::OwnedObjectPath,
    ) -> crate::zbus::Result<()>;

    /// Receive `SessionRemoved` signal.
    #[zbus(signal, name = "SessionRemoved")]
    fn session_removed(
        &self,
        session_id: String,
        object_path: crate::zvariant::OwnedObjectPath,
    ) -> crate::zbus::Result<()>;

    /// Receive `UserNew` signal.
    #[zbus(signal, name = "UserNew")]
    fn user_new(
        &self,
        uid: u32,
        object_path: crate::zvariant::OwnedObjectPath,
    ) -> crate::zbus::Result<()>;

    /// Receive `UserRemoved` signal.
    #[zbus(signal, name = "UserRemoved")]
    fn user_removed(
        &self,
        uid: u32,
        object_path: crate::zvariant::OwnedObjectPath,
    ) -> crate::zbus::Result<()>;

    /// Receive `SeatNew` signal.
    #[zbus(signal, name = "SeatNew")]
    fn seat_new(
        &self,
        seat_id: String,
        object_path: crate::zvariant::OwnedObjectPath,
    ) -> crate::zbus::Result<()>;

    /// Receive `SeatRemoved` signal.
    #[zbus(signal, name = "SeatRemoved")]
    fn seat_removed(
        &self,
        seat_id: String,
        object_path: crate::zvariant::OwnedObjectPath,
    ) -> crate::zbus::Result<()>;

    /// Receive `PrepareForShutdown` signal.
    #[zbus(signal, name = "PrepareForShutdown")]
    fn prepare_for_shutdown(&self, start: bool) -> crate::zbus::Result<()>;

    /// Receive `PrepareForShutdownWithMetadata` signal.
    #[zbus(signal, name = "PrepareForShutdownWithMetadata")]
    fn prepare_for_shutdown_with_metadata(
        &self,
        start: bool,
        metadata: ::std::collections::HashMap<String, crate::zvariant::OwnedValue>,
    ) -> crate::zbus::Result<()>;

    /// Receive `PrepareForSleep` signal.
    #[zbus(signal, name = "PrepareForSleep")]
    fn prepare_for_sleep(&self, start: bool) -> crate::zbus::Result<()>;

    /// Get property `EnableWallMessages`.
    #[zbus(property(emits_changed_signal = "false"), name = "EnableWallMessages")]
    fn enable_wall_messages(&self) -> crate::zbus::Result<bool>;

    /// Set property `EnableWallMessages`.
    #[zbus(property, name = "EnableWallMessages")]
    fn set_property_enable_wall_messages(&self, new_value: bool) -> crate::zbus::Result<()>;

    /// Get property `WallMessage`.
    #[zbus(property(emits_changed_signal = "false"), name = "WallMessage")]
    fn wall_message(&self) -> crate::zbus::Result<String>;

    /// Set property `WallMessage`.
    #[zbus(property, name = "WallMessage")]
    fn set_property_wall_message(&self, new_value: String) -> crate::zbus::Result<()>;

    /// Get property `NAutoVTs`.
    #[zbus(property(emits_changed_signal = "const"), name = "NAutoVTs")]
    fn n_auto_v_ts(&self) -> crate::zbus::Result<u32>;

    /// Get property `KillOnlyUsers`.
    #[zbus(property(emits_changed_signal = "const"), name = "KillOnlyUsers")]
    fn kill_only_users(&self) -> crate::zbus::Result<Vec<String>>;

    /// Get property `KillExcludeUsers`.
    #[zbus(property(emits_changed_signal = "const"), name = "KillExcludeUsers")]
    fn kill_exclude_users(&self) -> crate::zbus::Result<Vec<String>>;

    /// Get property `KillUserProcesses`.
    #[zbus(property(emits_changed_signal = "const"), name = "KillUserProcesses")]
    fn kill_user_processes(&self) -> crate::zbus::Result<bool>;

    /// Get property `RebootParameter`.
    #[zbus(property(emits_changed_signal = "false"), name = "RebootParameter")]
    fn reboot_parameter(&self) -> crate::zbus::Result<String>;

    /// Get property `RebootToFirmwareSetup`.
    #[zbus(
        property(emits_changed_signal = "false"),
        name = "RebootToFirmwareSetup"
    )]
    fn reboot_to_firmware_setup(&self) -> crate::zbus::Result<bool>;

    /// Get property `RebootToBootLoaderMenu`.
    #[zbus(
        property(emits_changed_signal = "false"),
        name = "RebootToBootLoaderMenu"
    )]
    fn reboot_to_boot_loader_menu(&self) -> crate::zbus::Result<u64>;

    /// Get property `RebootToBootLoaderEntry`.
    #[zbus(
        property(emits_changed_signal = "false"),
        name = "RebootToBootLoaderEntry"
    )]
    fn reboot_to_boot_loader_entry(&self) -> crate::zbus::Result<String>;

    /// Get property `BootLoaderEntries`.
    #[zbus(property(emits_changed_signal = "const"), name = "BootLoaderEntries")]
    fn boot_loader_entries(&self) -> crate::zbus::Result<Vec<String>>;

    /// Get property `IdleHint`.
    #[zbus(property(emits_changed_signal = "true"), name = "IdleHint")]
    fn idle_hint(&self) -> crate::zbus::Result<bool>;

    /// Get property `IdleSinceHint`.
    #[zbus(property(emits_changed_signal = "true"), name = "IdleSinceHint")]
    fn idle_since_hint(&self) -> crate::zbus::Result<u64>;

    /// Get property `IdleSinceHintMonotonic`.
    #[zbus(
        property(emits_changed_signal = "true"),
        name = "IdleSinceHintMonotonic"
    )]
    fn idle_since_hint_monotonic(&self) -> crate::zbus::Result<u64>;

    /// Get property `BlockInhibited`.
    #[zbus(property(emits_changed_signal = "true"), name = "BlockInhibited")]
    fn block_inhibited(&self) -> crate::zbus::Result<String>;

    /// Get property `DelayInhibited`.
    #[zbus(property(emits_changed_signal = "true"), name = "DelayInhibited")]
    fn delay_inhibited(&self) -> crate::zbus::Result<String>;

    /// Get property `InhibitDelayMaxUSec`.
    #[zbus(property(emits_changed_signal = "const"), name = "InhibitDelayMaxUSec")]
    fn inhibit_delay_max_u_sec(&self) -> crate::zbus::Result<u64>;

    /// Get property `UserStopDelayUSec`.
    #[zbus(property(emits_changed_signal = "const"), name = "UserStopDelayUSec")]
    fn user_stop_delay_u_sec(&self) -> crate::zbus::Result<u64>;

    /// Get property `SleepOperation`.
    #[zbus(property(emits_changed_signal = "const"), name = "SleepOperation")]
    fn sleep_operation(&self) -> crate::zbus::Result<Vec<String>>;

    /// Get property `HandlePowerKey`.
    #[zbus(property(emits_changed_signal = "const"), name = "HandlePowerKey")]
    fn handle_power_key(&self) -> crate::zbus::Result<String>;

    /// Get property `HandlePowerKeyLongPress`.
    #[zbus(
        property(emits_changed_signal = "const"),
        name = "HandlePowerKeyLongPress"
    )]
    fn handle_power_key_long_press(&self) -> crate::zbus::Result<String>;

    /// Get property `HandleRebootKey`.
    #[zbus(property(emits_changed_signal = "const"), name = "HandleRebootKey")]
    fn handle_reboot_key(&self) -> crate::zbus::Result<String>;

    /// Get property `HandleRebootKeyLongPress`.
    #[zbus(
        property(emits_changed_signal = "const"),
        name = "HandleRebootKeyLongPress"
    )]
    fn handle_reboot_key_long_press(&self) -> crate::zbus::Result<String>;

    /// Get property `HandleSuspendKey`.
    #[zbus(property(emits_changed_signal = "const"), name = "HandleSuspendKey")]
    fn handle_suspend_key(&self) -> crate::zbus::Result<String>;

    /// Get property `HandleSuspendKeyLongPress`.
    #[zbus(
        property(emits_changed_signal = "const"),
        name = "HandleSuspendKeyLongPress"
    )]
    fn handle_suspend_key_long_press(&self) -> crate::zbus::Result<String>;

    /// Get property `HandleHibernateKey`.
    #[zbus(property(emits_changed_signal = "const"), name = "HandleHibernateKey")]
    fn handle_hibernate_key(&self) -> crate::zbus::Result<String>;

    /// Get property `HandleHibernateKeyLongPress`.
    #[zbus(
        property(emits_changed_signal = "const"),
        name = "HandleHibernateKeyLongPress"
    )]
    fn handle_hibernate_key_long_press(&self) -> crate::zbus::Result<String>;

    /// Get property `HandleLidSwitch`.
    #[zbus(property(emits_changed_signal = "const"), name = "HandleLidSwitch")]
    fn handle_lid_switch(&self) -> crate::zbus::Result<String>;

    /// Get property `HandleLidSwitchExternalPower`.
    #[zbus(
        property(emits_changed_signal = "const"),
        name = "HandleLidSwitchExternalPower"
    )]
    fn handle_lid_switch_external_power(&self) -> crate::zbus::Result<String>;

    /// Get property `HandleLidSwitchDocked`.
    #[zbus(
        property(emits_changed_signal = "const"),
        name = "HandleLidSwitchDocked"
    )]
    fn handle_lid_switch_docked(&self) -> crate::zbus::Result<String>;

    /// Get property `HoldoffTimeoutUSec`.
    #[zbus(property(emits_changed_signal = "const"), name = "HoldoffTimeoutUSec")]
    fn holdoff_timeout_u_sec(&self) -> crate::zbus::Result<u64>;

    /// Get property `IdleAction`.
    #[zbus(property(emits_changed_signal = "const"), name = "IdleAction")]
    fn idle_action(&self) -> crate::zbus::Result<String>;

    /// Get property `IdleActionUSec`.
    #[zbus(property(emits_changed_signal = "const"), name = "IdleActionUSec")]
    fn idle_action_u_sec(&self) -> crate::zbus::Result<u64>;

    /// Get property `PreparingForShutdown`.
    #[zbus(
        property(emits_changed_signal = "false"),
        name = "PreparingForShutdown"
    )]
    fn preparing_for_shutdown(&self) -> crate::zbus::Result<bool>;

    /// Get property `PreparingForSleep`.
    #[zbus(property(emits_changed_signal = "false"), name = "PreparingForSleep")]
    fn preparing_for_sleep(&self) -> crate::zbus::Result<bool>;

    /// Get property `ScheduledShutdown`.
    #[zbus(property(emits_changed_signal = "false"), name = "ScheduledShutdown")]
    fn scheduled_shutdown(&self) -> crate::zbus::Result<(String, u64)>;

    /// Get property `Docked`.
    #[zbus(property(emits_changed_signal = "false"), name = "Docked")]
    fn docked(&self) -> crate::zbus::Result<bool>;

    /// Get property `LidClosed`.
    #[zbus(property(emits_changed_signal = "true"), name = "LidClosed")]
    fn lid_closed(&self) -> crate::zbus::Result<bool>;

    /// Get property `OnExternalPower`.
    #[zbus(property(emits_changed_signal = "false"), name = "OnExternalPower")]
    fn on_external_power(&self) -> crate::zbus::Result<bool>;

    /// Get property `RemoveIPC`.
    #[zbus(property(emits_changed_signal = "const"), name = "RemoveIPC")]
    fn remove_ipc(&self) -> crate::zbus::Result<bool>;

    /// Get property `RuntimeDirectorySize`.
    #[zbus(
        property(emits_changed_signal = "const"),
        name = "RuntimeDirectorySize"
    )]
    fn runtime_directory_size(&self) -> crate::zbus::Result<u64>;

    /// Get property `RuntimeDirectoryInodesMax`.
    #[zbus(
        property(emits_changed_signal = "const"),
        name = "RuntimeDirectoryInodesMax"
    )]
    fn runtime_directory_inodes_max(&self) -> crate::zbus::Result<u64>;

    /// Get property `InhibitorsMax`.
    #[zbus(property(emits_changed_signal = "const"), name = "InhibitorsMax")]
    fn inhibitors_max(&self) -> crate::zbus::Result<u64>;

    /// Get property `NCurrentInhibitors`.
    #[zbus(property(emits_changed_signal = "false"), name = "NCurrentInhibitors")]
    fn n_current_inhibitors(&self) -> crate::zbus::Result<u64>;

    /// Get property `SessionsMax`.
    #[zbus(property(emits_changed_signal = "const"), name = "SessionsMax")]
    fn sessions_max(&self) -> crate::zbus::Result<u64>;

    /// Get property `NCurrentSessions`.
    #[zbus(property(emits_changed_signal = "false"), name = "NCurrentSessions")]
    fn n_current_sessions(&self) -> crate::zbus::Result<u64>;

    /// Get property `StopIdleSessionUSec`.
    #[zbus(property(emits_changed_signal = "const"), name = "StopIdleSessionUSec")]
    fn stop_idle_session_u_sec(&self) -> crate::zbus::Result<u64>;
}

/// Proxy object for `org.freedesktop.login1.Seat`.
#[proxy(
    interface = "org.freedesktop.login1.Seat",
    gen_blocking = false,
    default_service = "org.freedesktop.login1",
    assume_defaults = false
)]
trait Seat {
    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#Terminate()) Call interface method `Terminate`.
    #[zbus(name = "Terminate")]
    fn terminate(&self) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#ActivateSession()) Call interface method `ActivateSession`.
    #[zbus(name = "ActivateSession")]
    fn activate_session(&self, session_id: String) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SwitchTo()) Call interface method `SwitchTo`.
    #[zbus(name = "SwitchTo")]
    fn switch_to(&self, vtnr: u32) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SwitchToNext()) Call interface method `SwitchToNext`.
    #[zbus(name = "SwitchToNext")]
    fn switch_to_next(&self) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SwitchToPrevious()) Call interface method `SwitchToPrevious`.
    #[zbus(name = "SwitchToPrevious")]
    fn switch_to_previous(&self) -> crate::zbus::Result<()>;

    /// Get property `Id`.
    #[zbus(property(emits_changed_signal = "const"), name = "Id")]
    fn id(&self) -> crate::zbus::Result<String>;

    /// Get property `ActiveSession`.
    #[zbus(property(emits_changed_signal = "true"), name = "ActiveSession")]
    fn active_session(&self) -> crate::zbus::Result<(String, crate::zvariant::OwnedObjectPath)>;

    /// Get property `CanTTY`.
    #[zbus(property(emits_changed_signal = "const"), name = "CanTTY")]
    fn can_tty(&self) -> crate::zbus::Result<bool>;

    /// Get property `CanGraphical`.
    #[zbus(property(emits_changed_signal = "true"), name = "CanGraphical")]
    fn can_graphical(&self) -> crate::zbus::Result<bool>;

    /// Get property `Sessions`.
    #[zbus(property(emits_changed_signal = "false"), name = "Sessions")]
    fn sessions(&self) -> crate::zbus::Result<Vec<(String, crate::zvariant::OwnedObjectPath)>>;

    /// Get property `IdleHint`.
    #[zbus(property(emits_changed_signal = "true"), name = "IdleHint")]
    fn idle_hint(&self) -> crate::zbus::Result<bool>;

    /// Get property `IdleSinceHint`.
    #[zbus(property(emits_changed_signal = "true"), name = "IdleSinceHint")]
    fn idle_since_hint(&self) -> crate::zbus::Result<u64>;

    /// Get property `IdleSinceHintMonotonic`.
    #[zbus(
        property(emits_changed_signal = "true"),
        name = "IdleSinceHintMonotonic"
    )]
    fn idle_since_hint_monotonic(&self) -> crate::zbus::Result<u64>;
}

/// Proxy object for `org.freedesktop.login1.User`.
#[proxy(
    interface = "org.freedesktop.login1.User",
    gen_blocking = false,
    default_service = "org.freedesktop.login1",
    assume_defaults = false
)]
trait User {
    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#Terminate()) Call interface method `Terminate`.
    #[zbus(name = "Terminate")]
    fn terminate(&self) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#Kill()) Call interface method `Kill`.
    #[zbus(name = "Kill")]
    fn kill(&self, signal_number: i32) -> crate::zbus::Result<()>;

    /// Get property `UID`.
    #[zbus(property(emits_changed_signal = "const"), name = "UID")]
    fn uid(&self) -> crate::zbus::Result<u32>;

    /// Get property `GID`.
    #[zbus(property(emits_changed_signal = "const"), name = "GID")]
    fn gid(&self) -> crate::zbus::Result<u32>;

    /// Get property `Name`.
    #[zbus(property(emits_changed_signal = "const"), name = "Name")]
    fn name(&self) -> crate::zbus::Result<String>;

    /// Get property `Timestamp`.
    #[zbus(property(emits_changed_signal = "const"), name = "Timestamp")]
    fn timestamp(&self) -> crate::zbus::Result<u64>;

    /// Get property `TimestampMonotonic`.
    #[zbus(property(emits_changed_signal = "const"), name = "TimestampMonotonic")]
    fn timestamp_monotonic(&self) -> crate::zbus::Result<u64>;

    /// Get property `RuntimePath`.
    #[zbus(property(emits_changed_signal = "const"), name = "RuntimePath")]
    fn runtime_path(&self) -> crate::zbus::Result<String>;

    /// Get property `Service`.
    #[zbus(property(emits_changed_signal = "const"), name = "Service")]
    fn service(&self) -> crate::zbus::Result<String>;

    /// Get property `Slice`.
    #[zbus(property(emits_changed_signal = "const"), name = "Slice")]
    fn slice(&self) -> crate::zbus::Result<String>;

    /// Get property `Display`.
    #[zbus(property(emits_changed_signal = "true"), name = "Display")]
    fn display(&self) -> crate::zbus::Result<(String, crate::zvariant::OwnedObjectPath)>;

    /// Get property `State`.
    #[zbus(property(emits_changed_signal = "false"), name = "State")]
    fn state(&self) -> crate::zbus::Result<String>;

    /// Get property `Sessions`.
    #[zbus(property(emits_changed_signal = "false"), name = "Sessions")]
    fn sessions(&self) -> crate::zbus::Result<Vec<(String, crate::zvariant::OwnedObjectPath)>>;

    /// Get property `IdleHint`.
    #[zbus(property(emits_changed_signal = "true"), name = "IdleHint")]
    fn idle_hint(&self) -> crate::zbus::Result<bool>;

    /// Get property `IdleSinceHint`.
    #[zbus(property(emits_changed_signal = "true"), name = "IdleSinceHint")]
    fn idle_since_hint(&self) -> crate::zbus::Result<u64>;

    /// Get property `IdleSinceHintMonotonic`.
    #[zbus(
        property(emits_changed_signal = "true"),
        name = "IdleSinceHintMonotonic"
    )]
    fn idle_since_hint_monotonic(&self) -> crate::zbus::Result<u64>;

    /// Get property `Linger`.
    #[zbus(property(emits_changed_signal = "false"), name = "Linger")]
    fn linger(&self) -> crate::zbus::Result<bool>;
}

/// Proxy object for `org.freedesktop.login1.Session`.
#[proxy(
    interface = "org.freedesktop.login1.Session",
    gen_blocking = false,
    default_service = "org.freedesktop.login1",
    assume_defaults = false
)]
trait Session {
    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#Terminate()) Call interface method `Terminate`.
    #[zbus(name = "Terminate")]
    fn terminate(&self) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#Activate()) Call interface method `Activate`.
    #[zbus(name = "Activate")]
    fn activate(&self) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#Lock()) Call interface method `Lock`.
    #[zbus(name = "Lock")]
    fn lock(&self) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#Unlock()) Call interface method `Unlock`.
    #[zbus(name = "Unlock")]
    fn unlock(&self) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SetIdleHint()) Call interface method `SetIdleHint`.
    #[zbus(name = "SetIdleHint")]
    fn set_idle_hint(&self, idle: bool) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SetLockedHint()) Call interface method `SetLockedHint`.
    #[zbus(name = "SetLockedHint")]
    fn set_locked_hint(&self, locked: bool) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#Kill()) Call interface method `Kill`.
    #[zbus(name = "Kill")]
    fn kill(&self, who: String, signal_number: i32) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#TakeControl()) Call interface method `TakeControl`.
    #[zbus(name = "TakeControl")]
    fn take_control(&self, force: bool) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#ReleaseControl()) Call interface method `ReleaseControl`.
    #[zbus(name = "ReleaseControl")]
    fn release_control(&self) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SetType()) Call interface method `SetType`.
    #[zbus(name = "SetType")]
    fn set_type(&self, typelabel: String) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SetClass()) Call interface method `SetClass`.
    #[zbus(name = "SetClass")]
    fn set_class(&self, class: String) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SetDisplay()) Call interface method `SetDisplay`.
    #[zbus(name = "SetDisplay")]
    fn set_display(&self, display: String) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SetTTY()) Call interface method `SetTTY`.
    #[zbus(name = "SetTTY")]
    fn set_tty(&self, tty_fd: crate::zvariant::OwnedFd) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#TakeDevice()) Call interface method `TakeDevice`.
    #[zbus(name = "TakeDevice")]
    fn take_device(
        &self,
        major: u32,
        minor: u32,
    ) -> crate::zbus::Result<(crate::zvariant::OwnedFd, bool)>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#ReleaseDevice()) Call interface method `ReleaseDevice`.
    #[zbus(name = "ReleaseDevice")]
    fn release_device(&self, major: u32, minor: u32) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#PauseDeviceComplete()) Call interface method `PauseDeviceComplete`.
    #[zbus(name = "PauseDeviceComplete")]
    fn pause_device_complete(&self, major: u32, minor: u32) -> crate::zbus::Result<()>;

    /// [📖](https://www.freedesktop.org/software/systemd/man/systemd.directives.html#SetBrightness()) Call interface method `SetBrightness`.
    #[zbus(name = "SetBrightness")]
    fn set_brightness(
        &self,
        subsystem: String,
        name: String,
        brightness: u32,
    ) -> crate::zbus::Result<()>;

    /// Receive `PauseDevice` signal.
    #[zbus(signal, name = "PauseDevice")]
    fn pause_device(&self, major: u32, minor: u32, typelabel: String) -> crate::zbus::Result<()>;

    /// Receive `ResumeDevice` signal.
    #[zbus(signal, name = "ResumeDevice")]
    fn resume_device(
        &self,
        major: u32,
        minor: u32,
        fd: crate::zvariant::OwnedFd,
    ) -> crate::zbus::Result<()>;

    /// Receive `Lock` signal.
    #[zbus(signal, name = "Lock")]
    fn lock(&self) -> crate::zbus::Result<()>;

    /// Receive `Unlock` signal.
    #[zbus(signal, name = "Unlock")]
    fn unlock(&self) -> crate::zbus::Result<()>;

    /// Get property `Id`.
    #[zbus(property(emits_changed_signal = "const"), name = "Id")]
    fn id(&self) -> crate::zbus::Result<String>;

    /// Get property `User`.
    #[zbus(property(emits_changed_signal = "const"), name = "User")]
    fn user(&self) -> crate::zbus::Result<(u32, crate::zvariant::OwnedObjectPath)>;

    /// Get property `Name`.
    #[zbus(property(emits_changed_signal = "const"), name = "Name")]
    fn name(&self) -> crate::zbus::Result<String>;

    /// Get property `Timestamp`.
    #[zbus(property(emits_changed_signal = "const"), name = "Timestamp")]
    fn timestamp(&self) -> crate::zbus::Result<u64>;

    /// Get property `TimestampMonotonic`.
    #[zbus(property(emits_changed_signal = "const"), name = "TimestampMonotonic")]
    fn timestamp_monotonic(&self) -> crate::zbus::Result<u64>;

    /// Get property `VTNr`.
    #[zbus(property(emits_changed_signal = "const"), name = "VTNr")]
    fn vt_nr(&self) -> crate::zbus::Result<u32>;

    /// Get property `Seat`.
    #[zbus(property(emits_changed_signal = "const"), name = "Seat")]
    fn seat(&self) -> crate::zbus::Result<(String, crate::zvariant::OwnedObjectPath)>;

    /// Get property `TTY`.
    #[zbus(property(emits_changed_signal = "true"), name = "TTY")]
    fn tty(&self) -> crate::zbus::Result<String>;

    /// Get property `Display`.
    #[zbus(property(emits_changed_signal = "true"), name = "Display")]
    fn display(&self) -> crate::zbus::Result<String>;

    /// Get property `Remote`.
    #[zbus(property(emits_changed_signal = "const"), name = "Remote")]
    fn remote(&self) -> crate::zbus::Result<bool>;

    /// Get property `RemoteHost`.
    #[zbus(property(emits_changed_signal = "const"), name = "RemoteHost")]
    fn remote_host(&self) -> crate::zbus::Result<String>;

    /// Get property `RemoteUser`.
    #[zbus(property(emits_changed_signal = "const"), name = "RemoteUser")]
    fn remote_user(&self) -> crate::zbus::Result<String>;

    /// Get property `Service`.
    #[zbus(property(emits_changed_signal = "const"), name = "Service")]
    fn service(&self) -> crate::zbus::Result<String>;

    /// Get property `Desktop`.
    #[zbus(property(emits_changed_signal = "const"), name = "Desktop")]
    fn desktop(&self) -> crate::zbus::Result<String>;

    /// Get property `Scope`.
    #[zbus(property(emits_changed_signal = "const"), name = "Scope")]
    fn scope(&self) -> crate::zbus::Result<String>;

    /// Get property `Leader`.
    #[zbus(property(emits_changed_signal = "const"), name = "Leader")]
    fn leader(&self) -> crate::zbus::Result<u32>;

    /// Get property `Audit`.
    #[zbus(property(emits_changed_signal = "const"), name = "Audit")]
    fn audit(&self) -> crate::zbus::Result<u32>;

    /// Get property `Type`.
    #[zbus(property(emits_changed_signal = "true"), name = "Type")]
    fn type_property(&self) -> crate::zbus::Result<String>;

    /// Get property `Class`.
    #[zbus(property(emits_changed_signal = "true"), name = "Class")]
    fn class(&self) -> crate::zbus::Result<String>;

    /// Get property `Active`.
    #[zbus(property(emits_changed_signal = "true"), name = "Active")]
    fn active(&self) -> crate::zbus::Result<bool>;

    /// Get property `State`.
    #[zbus(property(emits_changed_signal = "true"), name = "State")]
    fn state(&self) -> crate::zbus::Result<String>;

    /// Get property `IdleHint`.
    #[zbus(property(emits_changed_signal = "true"), name = "IdleHint")]
    fn idle_hint(&self) -> crate::zbus::Result<bool>;

    /// Get property `IdleSinceHint`.
    #[zbus(property(emits_changed_signal = "true"), name = "IdleSinceHint")]
    fn idle_since_hint(&self) -> crate::zbus::Result<u64>;

    /// Get property `IdleSinceHintMonotonic`.
    #[zbus(
        property(emits_changed_signal = "true"),
        name = "IdleSinceHintMonotonic"
    )]
    fn idle_since_hint_monotonic(&self) -> crate::zbus::Result<u64>;

    /// Get property `LockedHint`.
    #[zbus(property(emits_changed_signal = "true"), name = "LockedHint")]
    fn locked_hint(&self) -> crate::zbus::Result<bool>;
}
